// Task Alarm
//Author Plamenka Hristova
#include "stdio.h"
#include "math.h"
#include <cstdlib>

 int num_alarms;
 int plass[2][31];
 int used[31];
 int path;
 int min_path;
 int alarm;
 int a_x,a_y;
 int k_x,k_y;

void find_path()
{
 int i;
 int g_x,g_y;

 if (alarm == 0)
 {
   path += abs(a_x - k_x) + abs(a_y - k_y);
   if (path < min_path)
        min_path = path;
   path -= abs(a_x - k_x) + abs(a_y - k_y);
 }

 alarm--;
 g_x = a_x;
 g_y = a_y;

 for(i=1;i<=num_alarms;i++)
 {
  if (used[i] == 0)
  {
   used[i] = 1;
   path += abs(g_x - plass[0][i]) + abs(g_y - plass[1][i]);
   a_x = plass[0][i];
   a_y = plass[1][i];
   find_path();
   a_x = g_x;
   a_y = g_y;
   path -= abs(g_x - plass[0][i]) + abs(g_y - plass[1][i]);
   used[i] = 0;
  }
 }
 alarm++;
}

main()
{
 int j;
 int x_size,y_size;
 int b_x,b_y;

  scanf("%d %d",&x_size,&y_size);
  scanf("%d %d",&k_x,&k_y);
  scanf("%d",&num_alarms);

  for(j=1;j<=num_alarms;j++)
  {
   scanf("%d %d",&b_x,&b_y);
   plass[0][j]= b_x;
   plass[1][j]= b_y;
   used[j] = 0;
  }
  min_path = 10000000;
  alarm = num_alarms;
  path = 0;
  a_x = k_x;
  a_y = k_y;
  find_path();
  printf("%d\n",min_path);
}
